#!/usr/bin/env ruby

##
# UPnPwn v0.8.0-bh
# Copyright 2008 Jonathan Squire, CISSP
##


##
## Some constants are missing in windows... let's define them
## per: http://rubyforge.org/snippet/detail.php?type=snippet&id=279
## per: http://rubyforge.org/snippet/detail.php?type=snippet&id=280
##
Socket::IP_MULTICAST_IF = 9 unless Socket.const_defined?('IP_MULTICAST_IF')
Socket::IP_MULTICAST_TTL = 10 unless Socket.const_defined?('IP_MULTICAST_TTL')
Socket::IP_MULTICAST_LOOP = 11 unless Socket.const_defined?('IP_MULTICAST_LOOP')
Socket::IP_ADD_MEMBERSHIP = 12 unless Socket.const_defined?('IP_ADD_MEMBERSHIP')

#
# Send a terminal clear on unix
#
def clear_screen
  print "\e[2J\e[f"
end

def print_hash(hash)
	puts "=== print_hash ==="
	hash.each do |key,value|
	  puts "#{key} => #{value}"
	end
end

def dump_object(object)
	output = ""
	output << "=== dump_object ===\n"
	output << "#{object.class}\n"
	output << "\n"
	output << "Public Methods:\n"
	output << "     #{object.public_methods(false).sort * ","}\n"
	output << "\n"
	output << "Instance Variables:\n"
	output << "     #{object.instance_variables.sort * ","}\n"
	output << "\n"
	output << "\n"

	puts output
end


#
# Inputs:
# action -- name of the method
# inputs -- an array containing the input names
# outputs -- an aray containing the outputs for the method
#
def print_action(action,inputs=nil,outputs=nil)
	puts "#########################"
	puts "## #{action}"
	puts "##"
	
	print "##      #{action}("
	if(inputs.size > 0)
	  print "'" + inputs * "','" + "'"
	end
	print ")\n"
	
	puts "##"
	puts "## Returns: " + outputs * ","
	puts "##"	
end

#
# http://snippets.dzone.com/posts/show/2452
#
def local_ip
  ifconfig = %x(which /sbin/ifconfig).strip
  %x(ifconfig).split("lo").shift =~ /inet addr\:(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\s/
  $1
end
